#include "NNPDFDriver.h"
#include "LHAPDF/LHAPDF.h"
#include <cmath>
#include <iomanip>
using namespace std;

int main()
{
  string gridname = "NNPDF23_lo_as_0119_qed_mem0.LHgrid";

  NNPDFDriver *nnpdf = new NNPDFDriver(gridname);

  string xpdf[] = {"x*tbar","x*bbar","x*cbar","x*sbar","x*ubar","x*dbar",
		   "x*g","x*d","x*u","x*s","x*c","x*b","x*t","x*photon"};
  double xlha[] = {1e-7, 1e-6, 1e-5, 1e-4, 1e-3, 1e-2,
		   1e-1, 3e-1, 5e-1, 7e-1, 9e-1};  
  double Q2[] = { 2.0, 10.0, 100.0, 1000.0, 10000.0 };
  
  LHAPDF::initPDFSet(gridname);

  double sum = 0;
  for (int f = -6; f <= 7; f++)
    {
      for (int iq = 0; iq < 5; iq++)
	{	
	  cout << "  " << xpdf[f+6] << ", Q2 = " << Q2[iq] << endl;
	  cout << "   x \t     C++ \tLHAPDF" << endl;
	  for (int ix = 0; ix < 11; ix++)
	    {
	      double a = nnpdf->xfxphoton(xlha[ix],sqrt(Q2[iq]),f);
	      double b = LHAPDF::xfxphoton(xlha[ix],sqrt(Q2[iq]),f);
	      cout << scientific << setprecision(1) << xlha[ix] << "  ";
	      cout << scientific << setprecision(5) << a << "  " << b << endl;
	      sum += a-b;
	    } 
	  cout << endl;
	}
    }

  if (sum != 0)
    cout << "Problems in the interpolation..." << endl;    

  delete nnpdf;

  return 0;
}
